#!/bin/sh
# alt-pupsave-create4.sh
# Purpose: alternative pupsave creation script.
# musher0, Nov. 29, 2013; edited Nov. 30 and Dec. 1, 2013.
#
# Thanks to Karl_Godt and L18L for their feedback.
####
unset NOM
DRV="sda1"
function create {
dd if=/dev/zero of="$NOM"save-arf.2fs bs=1k count=393000
[ $? = 0 ] || { echo "Sorry, unable to create savefile correctly. Exiting."; return 1; }
mkfs.ext2 -q -m 0 -F "$NOM"save-arf.2fs
[ $? = 0 ] || { echo "Sorry, unable to create filesystem in savefile. Exiting."; return 1; }
return 0
}
clear
echo "Alternative pupsave creation script"
echo "   by musher0, Nov. 30, 2013."
echo "      ~~~~~~~~~~~~~~~~~~~"
echo "-- Please note --  This script:"
echo "1) does not ask where to store the pupsave file. It stores"
echo "__ it by default at the top level of /mnt/sda1,"
echo "2) it only creates ext2 file systems,"
echo "3) of 384 Mb only, and"
echo "4) you can't customize the file name from within this script."
echo
echo "Let's all be clear that this is a workaround, and that some"
echo "of the work will have to be done by you, the user. It should"
echo " be used when the normal pupsave creation sequence fails to"
echo " create a personal save file. (The bug has been known to occur"
echo " on older computers using an external drive, for example.)"
echo
echo "If those limitations do not suit you, press Ctrl+C to exit."
echo "Or press Return to begin."
read
clear
echo
echo "A few checks will now be done. Please wait a few seconds."
echo
# various checks
if [ "`blkid | grep \"v/sd\"`" = "" ];then
	echo "You are on a diskless computer. Please save your Puppy"
	echo "session on CD or DVD in multi-session mode using the"
	echo "normal Puppy shutdown sequence."
elif [ "`blkid | grep "$DRV" | grep ntfs`" ];then
	echo "Your "$DRV" partition is in ntfs format. It should not be altered"
	echo "from an outside Linux script. Alternatives are suggested at:"
	echo "http://puppylinux.info/topic/53-advice-needed."
	echo "[1]: go there; [2]: use /mnt/sdb1 instead (can be a USB drive);"
	echo "[any other key]: exit."
	read B
	case $B in
		1)exec rox -U http://puppylinux.info/topic/53-advice-needed;;
		2)unset DRV;DRV="sdb1"
		echo "Please connect your formated drive (if USB);"
		echo "press Return to continue."
		read
		echo "We check again... Please wait a few seconds."
		if [ "`blkid | grep "$DRV" | grep ntfs`" ];then
			echo "This "$DRV" partition is also in ntfs format."
			echo "It should not be altered from a Linux script."
			echo "This script will now exit."
			exit
		fi;;
		*)exit;;
	esac
else
	mkdir -p /mnt/"$DRV"
	mount /dev/"$DRV" /mnt/"$DRV" >/dev/null 2>&1 
	echo "A Linux partition is mounted at /mnt/sda1. So we continue."
	cd /mnt/sda1
	echo
	echo "Here are the names of some recent Puppies:"
	echo
	echo "  CE dpup kdpup lupu polar precise quirky"
	echo "  racy raring slacko sulu wary wheezy wolx"
	echo
	echo "Type in your Puppy's name. Please check the spelling!"
	echo "During the process, if asked, press [y]es."
	read NOM
	echo "~~~~~~~~~~~~~~~"
	case $NOM in
	CE|dpup|kdpup|lupu|polar|precise|quirky|racy|raring|slacko|sulu|wary|wheezy|wolx)
	create;;
	*)echo
	echo "The name that you provided is not in the above list."
	echo "Type [y] if it's ok to continue."
	echo
	read A
	if [ "$A" = "y" ];then
		create
		else
			echo
			echo "Please check the basic name of your pupsave"
			echo "and rerun this script."
			exit
	fi;;
	esac
	echo "~~~~~~~~~~~~~~~"
	sleep 2s
	clear
	echo
	echo "Done! Your new pupsave file should be on partition /mnt/"$DRV"."
	rox /mnt/"$DRV"
	echo "You can leave it there, but it is suggested that you create a folder,"
	echo "give it your Puppy's name and move the newly created file in it,"
	echo "to keep things organized. You can change manually the part of "
	echo "the file name between the hyphen and the dot, if you so wish."
	echo
	echo "You can now reboot your Puppy. It will load the newly created"
	echo ""$NOM"save file automatically."
	echo
	echo "Have a great day!"
	echo
fi
## 30 ##
